void free_matrix(double **m);
void dir_prod(double **mat1 , double **mat2 , int dim);
void init_pos(double **mat , int dim1 , int dim2);
double pythag(double a , double b);
void tqli(double d[] , double e[] , int dim , double **mat);
void householder(double **mat , int dim , double d[] , double e[]);
long **matrix_l(int nrow, int ncol);
double **matrix(int nrow, int ncol);
void mult_vect(double vect[] , double **mat , int dim);
long compute_cholesky(double **mat , int dim , double **vect);
void solve_sys(double **mat, int dim, double **vect, double **b , double **v);
extern double gaussian(double *vect1 , double *vect2 , long dim);
extern double polynomial(double *vect1 , double *vect2 , long dim);
extern double prod_scal(double *vect1 , double *vect2 , long dim);
extern double ker(int nat, double *vect1, double *vect2, long dim);
void trans_mat(double **mat1 , double **mat2 , int dim1 , int dim2);
extern compute_trace(double *pmat , int dim);
void add_mat(double **mat1 , double **mat2 , double **mat3 ,
                int dim1 , int dim2);
void sub_mat(double **mat1 , double **mat2 , double **mat3 ,
                int dim1 , int dim2);
void sub_mat1(double **mat1 , double **mat2 , int dim1 , int dim2);
void add_mat1(double **mat1 , double **mat2 , int dim1 , int dim2);
void scal_mat(double coeff , double **mat1 , double **mat2 ,
                 int dim1 , int dim2);
void scal_mat1(double coeff , double **mat , int dim1 , int dim2);
void mult_mat(double **mat1 , double **mat2 , double **mat3 ,
                 int dim1 , int dim2 , int dim3);
void display_mat_l(long **mat , long dim1 , long dim2, long par1);
void display_mat(double **mat , long dim1 , long dim2 , long par1 , long par2);
void display_mat1(double **mat1 , double **mat2 , int dim1 , int dim2 ,
                  int par1 , int par2);
void project(double **mat , int dim1 , int dim2);
void copy(double **mat1 , double **mat2 , long dim1 , long dim2);
extern compare(double **mat1 , double **mat2 , int dim1 , int dim2 , double seuil);
void pseudo_inverse(double **mat, long dim);
void inverse(double **mat, long dim);
double compute_det(double **mat, int dim);
void compute_inv(double **mat, double **mat_1, int dim);
